Synchronizing your UI with the browser URL is considered good practice.
It lets your users take one of your results pages, copy the URL, and share it.
It also improves the user experience by enabling the use of the back and next browser buttons to keep track of previous searches.InstantSearch provides the necessary API entries to let you synchronize the state of your search UI (your refined widgets and current ) with any kind of storage.This is possible with the routing option.
This guide focuses on storing the UI state in the browser URL.When you are using routing, you can’t use initial-ui-state
because the two options override each other.
Simple and static use cases can be more straightforward using initial-ui-state, but anything dynamic or complex should use routing.
This URL is accurate and can be translated back to a search UI state. However, this isn’t the most human-readable, or optimized for search engines. The next section shows how to make it more SEO-friendly.
The default URLs that InstantSearch generates are comprehensive, but if you have many widgets,
this can also generate noise.
You may want to decide what goes in the URL and what doesn’t,
or even rename the query parameters to something that makes more sense to you.The stateMapping defines how to go from InstantSearch’s internal state to a URL, and vice versa.
You can override it to rename query parameters and choose what to include in the URL.
InstantSearch manages uiState.The state contains information about the user’s search, including the query,
the selection,
the page being viewed,
and the widget hierarchy.
uiState only stores modified widget values, not defaults.To persist this state in the URL,
InstantSearch converts the uiState into an object called routeState:
this routeState then becomes a URL.
Conversely, when InstantSearch reads the URL and applies it to the search,
it converts routeState into uiState.
This logic lives in two functions:
This guide uses the router from InstantSearch.js.
Make sure you add instantsearch.js to your project’s dependencies in addition to vue-instantsearch.
URLs are more than query parameters.
Another important part is the path.
Manipulating the URL path is a common ecommerce pattern that better references your page results.
In this section, you’ll learn how to create this kind of URLs:
This URL is composed of the path which now includes /search, then /Cell+Phones for the category. The query parameters are also simplified by only using the attribute name as the key. This requires you to have only one widget per attribute.
In the following SEO-friendly example the brand is stored in the path, and the query and page as query parameters.
JavaScript
Report incorrect code
Copy
import { history as historyRouter } from 'instantsearch.js/es/lib/routers';// Returns a slug from the category name.// Spaces are replaced by "+" to make// the URL easier to read and other// characters are encoded.function getCategorySlug(name) { return name .split(' ') .map(encodeURIComponent) .join('+');}// Returns a name from the category slug.// The "+" are replaced by spaces and other// characters are decoded.function getCategoryName(slug) { return slug .split('+') .map(decodeURIComponent) .join(' ');}const routing = { router: historyRouter({ windowTitle({ category, query }) { const queryTitle = query ? `Results for "${query}"` : 'Search'; if (category) { return `${category} – ${queryTitle}`; } return queryTitle; }, createURL({ qsModule, routeState, location }) { const urlParts = location.href.match(/^(.*?)\/search/); const baseUrl = `${urlParts ? urlParts[1] : ''}/`; const categoryPath = routeState.category ? `${getCategorySlug(routeState.category)}/` : ''; const queryParameters = {}; if (routeState.query) { queryParameters.query = encodeURIComponent(routeState.query); } if (routeState.page !== 1) { queryParameters.page = routeState.page; } if (routeState.brands) { queryParameters.brands = routeState.brands.map(encodeURIComponent); } const queryString = qsModule.stringify(queryParameters, { addQueryPrefix: true, arrayFormat: 'repeat', }); return `${baseUrl}search/${categoryPath}${queryString}`; }, parseURL({ qsModule, location }) { const pathnameMatches = location.pathname.match(/search\/(.*?)\/?$/); const category = getCategoryName( (pathnameMatches && pathnameMatches[1]) || '' ); const { query = '', page, brands = [] } = qsModule.parse( location.search.slice(1) ); // `qs` does not return an array when there's a single value. const allBrands = Array.isArray(brands) ? brands : [brands].filter(Boolean); return { query: decodeURIComponent(query), page, brands: allBrands.map(decodeURIComponent), category, }; }, }), stateMapping: { stateToRoute(uiState) { const indexUiState = uiState['instant_search'] || {}; return { query: indexUiState.query, page: indexUiState.page, brands: indexUiState.refinementList && indexUiState.refinementList.brand, category: indexUiState.menu && indexUiState.menu.categories }; }, routeToState(routeState) { return { instant_search: { query: routeState.query, page: routeState.page, menu: { categories: routeState.category }, refinementList: { brand: routeState.brands }, }, }; }, }, },};
The basic routing example uses the history router with no extra customization.
Here you’re also using the history router but explicitly setting configuration options.
The router and stateMapping options are used to map uiState to routeState, and vice versa.Using the routing option as an object, configure:
windowTitle: a method to map the routeState object returned from stateToRoute to the window title.
createURL: a method called every time you need to create a URL. This should be done when:
You want to synchronize the routeState to the browser URL,
You want to render a tags in the menu widget,
You call createURL in one of your connectors’ rendering methods.
parseURL: a method called every time users load or reload the page, or click the browser’s back or next buttons.
In real-life apps, you might want to make specific categories easier to access by associating them with readable and memorable URLs.Given the dataset, you can make some categories more discoverable:
“Cameras and camcorders” → /Cameras
“Car electronics and GPS” → /Cars
In this example, whenever users visit https://example.org/search/Cameras, it pre-selects the “Cameras and camcorders” filter.
This is achieved with a dictionary:
JavaScript
Report incorrect code
Copy
// Step 1. Add the dictionaries to convert the names and the slugsconst encodedCategories = { Cameras: "Cameras and camcorders", Cars: "Car electronics and GPS", Phones: "Phones", TV: "TV and home theater",};const decodedCategories = Object.keys(encodedCategories).reduce((acc, key) => { const newKey = encodedCategories[key]; const newValue = key; return { ...acc, [newKey]: newValue, };}, {});// Step 2. Update the getters to use the encoded/decoded valuesfunction getCategorySlug(name) { const encodedName = decodedCategories[name] || name; return encodedName.split(" ").map(encodeURIComponent).join("+");}function getCategoryName(slug) { const decodedSlug = encodedCategories[slug] || slug; return decodedSlug.split("+").map(decodeURIComponent).join(" ");}
You can build these dictionaries from your Algolia .With such a solution, you have full control over what categories are discoverable from the URL.
For your search results to be part of a public search engine’s results, you must be selective.
Trying to index too many search results pages could be considered spam.To do that, create a robots.txt and host it at https://example.org/robots.txt.Here’s an example based on the URL scheme you created.
The previous examples were using the InstantSearch router. This is fine in almost all of the use cases, but if you plan on using Vue Router too, and also plan on reading the URL with Vue Router in the search page to show something outside of the InstantSearch life cycle, you can choose to synchronize with Vue Router. This isn’t necessary if you are using Vue Router and aren’t planning to read from the URL.Instead of using historyRouter, a new one is written from scratch. The router key expects an object with the following keys as values:
JavaScript
Report incorrect code
Copy
const routing = { router: { read() { /* Read from the URL and return a routeState */ }, write(routeState) { /* Write to the URL */ }, createURL(routeState) { /* Return a URL as a string */ }, onUpdate(callback) { /* Call this callback whenever the URL changes externally */ }, dispose() { /* Remove any listeners */ }, },};
For simplicity, in this example, a stateMapping won’t be completed. The default configuration of Vue Router doesn’t allow deeply nested URLs, so that must be implemented first in main.js:
JavaScript
Report incorrect code
Copy
import qs from "qs";const router = new Router({ routes: [ // ... ], // set custom query resolver parseQuery(query) { return qs.parse(query); }, stringifyQuery(query) { const result = qs.stringify(query); return result ? `?${result}` : ""; },});
Fill in the router key on the routing object in the data function:
Applies to Vue InstantSearch v2 and later.If you enable InstantSearch routing, only the parameters coming from widgets are included in the URL.
To keep other parameters unrelated to InstantSearch, add them when implementing createURL.For example, to keep all URL parameters that start with utm_,
use the following code:
JavaScript
Report incorrect code
Copy
history({ // ... other options parseURL({ qsModule, location }) { return qsModule.parse(location.search.slice(1)); }, createURL({ qsModule, location, routeState }) { const { origin, pathname, hash } = location; const queriesFromUrl = qsModule.parse(location.search.slice(1)); // Get all parameters from the URL that are not in the InstantSearch state and that start with "utm_" const utmQueries = Object.fromEntries( Object.entries(queriesFromUrl).filter( ([key]) => !Object.keys(routeState).includes(key) && // Add here a condition to keep the parameters you want, for example starting with "utm_" key.startsWith("utm_"), ), ); // Create query string with InstantSearch state and other parameters const queryString = qsModule.stringify( { ...routeState, ...utmQueries, }, { addQueryPrefix: true, arrayFormat: "repeat", }, ); return `${origin}${pathname}${queryString}${hash}`; },});
To enable routing in a Nuxt app,
you can’t use the createServerRootMixin factory as a mixin as usual,
because you need to access Vue Router which is only available on the component instance.Here’s the workaround:
Use createServerRootMixin in data, so this.$router is available.
Create an InstantSearch router that wraps Vue Router.
Set up provide as the root mixin would otherwise do.
Applies to Vue InstantSearch v1 and later.If you want to group, for example, “turquoise”, “ocean” and “sky” under “blue”, the recommended solution is to group them at indexing time.
You can either add the group name as a separate attribute to globally filter on, or add both values in an array to make both the group and the individual value show up in the list.For example, with the following dataset: